Index: vendors/IOIPSL/current/src/histcom.f90
===================================================================
--- vendors/IOIPSL/current/src/histcom.f90	(revision 1989)
+++ vendors/IOIPSL/current/src/histcom.f90	(revision 1991)
@@ -1918,9 +1834,9 @@
 !-
   IF ((TRIM(tmp_opp) /= "once").AND.(TRIM(tmp_opp) /= "never")) THEN
-    last_opp_chk(pfileid,varid) = pitau
-    last_wrt_chk(pfileid,varid) = pitau
+    W_F(idf)%W_V(iv)%last_opp_chk = pitau
+    W_F(idf)%W_V(iv)%last_wrt_chk = pitau
   ELSE
-    last_opp_chk(pfileid,varid) = -99
-    last_wrt_chk(pfileid,varid) = -99
+    W_F(idf)%W_V(iv)%last_opp_chk = -99
+    W_F(idf)%W_V(iv)%last_wrt_chk = -99
   ENDIF
 !-----------------------
@@ -1928,5 +1844,5 @@
 !===
 SUBROUTINE histwrite_real &
- & (pfileid,varid,pitau,nbdpt,buff_tmp,nbindex,nindex,do_oper,do_write)
+ & (idf,iv,pitau,nbdpt,tbf_1,nbindex,nindex,do_oper,do_write)
 !---------------------------------------------------------------------
 !- This subroutine is internal and does the calculations and writing
@@ -1936,10 +1852,10 @@
   IMPLICIT NONE
 !-
-  INTEGER,INTENT(IN) :: pfileid,pitau,varid, &
+  INTEGER,INTENT(IN) :: idf,pitau,iv, &
  &                      nbindex,nindex(nbindex),nbdpt
-  REAL,DIMENSION(:)  :: buff_tmp
+  REAL,DIMENSION(:)  :: tbf_1
   LOGICAL,INTENT(IN) :: do_oper,do_write
 !-
-  INTEGER :: tsz,ncid,ncvarid,i,iret,ipt,itax,io,nbin,nbout
+  INTEGER :: tsz,nfid,nvid,iret,itax,io,nbin,nbout
   INTEGER :: nx,ny,nz,ky,kz,kt,kc
   INTEGER,DIMENSION(4) :: corner,edges
@@ -1947,7 +1863,7 @@
 !-
   REAL :: rtime
+  REAL,DIMENSION(2) :: t_bnd
   CHARACTER(LEN=7) :: tmp_opp
-  REAL,ALLOCATABLE,DIMENSION(:),SAVE :: buff_tmp2,buffer_used
-  INTEGER,SAVE :: buff_tmp2_sz,buffer_sz
+  REAL,ALLOCATABLE,DIMENSION(:),SAVE :: tbf_2
   LOGICAL :: l_dbg
 !---------------------------------------------------------------------
@@ -1955,80 +1871,45 @@
 !-
   IF (l_dbg) THEN
-    WRITE(*,*) "histwrite 0.0 : VAR : ",name(pfileid,varid)
-    WRITE(*,*) "histwrite 0.0 : nbindex,nindex :", &
- &  nbindex,nindex(1:MIN(3,nbindex)),'...',nindex(MAX(1,nbindex-3):nbindex)
+    WRITE(*,*) "histwrite 0.0 : VAR : ",W_F(idf)%W_V(iv)%v_name
+    WRITE(*,*) "histwrite 0.0 : nbindex :",nbindex
+    WRITE(*,*) "histwrite 0.0 : nindex  :",nindex(1:MIN(3,nbindex)),'...'
   ENDIF
 !-
 ! The sizes which can be encoutered
 !-
-  tsz =  zsize(pfileid,varid,1) &
- &      *zsize(pfileid,varid,2) &
- &      *zsize(pfileid,varid,3)
-!-
-! 1.0 We allocate the memory needed to store the data between write
-!     and the temporary space needed for operations.
-!     We have to keep precedent buffer if needed
-!-
-  IF (.NOT. ALLOCATED(buffer)) THEN
-    IF (l_dbg) WRITE(*,*) "histwrite_real 1.0 allocate buffer ",buff_pos
-    ALLOCATE(buffer(buff_pos))
-    buffer_sz = buff_pos
-    buffer(:)=0.0
-  ELSE IF (buffer_sz < buff_pos) THEN
+  tsz =  W_F(idf)%W_V(iv)%zsize(1) &
+ &      *W_F(idf)%W_V(iv)%zsize(2) &
+ &      *W_F(idf)%W_V(iv)%zsize(3)
+!-
+! 1.0 We allocate and the temporary space needed for operations.
+!     The buffers are only deallocated when more space is needed.
+!     This reduces the umber of allocates but increases memory needs.
+!-
+  IF (.NOT.ALLOCATED(tbf_2)) THEN
     IF (l_dbg) THEN
-      WRITE(*,*) "histwrite_real 1.0.1 re-allocate buffer for ", &
- &      buff_pos," instead of ",SIZE(buffer)
-    ENDIF
-    IF (SUM(buffer)/=0.0) THEN
-      IF (l_dbg) WRITE (*,*) 'histwrite : buffer has been used. ', &
- &      'We have to save it before re-allocating.'
-      ALLOCATE(buffer_used(buffer_sz))
-      buffer_used(:)=buffer(:)
-      DEALLOCATE(buffer)
-      ALLOCATE(buffer(buff_pos))
-      buffer_sz = buff_pos
-      buffer(:)=0.0
-      buffer(:SIZE(buffer_used))=buffer_used
-      DEALLOCATE(buffer_used)
-    ELSE
-      IF (l_dbg) WRITE (*,*) 'histwrite : buffer has not been used. ', &
- &      'We have just to re-allocate it.'
-      DEALLOCATE(buffer)
-      ALLOCATE(buffer(buff_pos))
-      buffer_sz = buff_pos
-      buffer(:)=0.0
-    ENDIF
-  ENDIF
-!-
-! The buffers are only deallocated when more space is needed. This
-! reduces the umber of allocates but increases memory needs.
-!-
-  IF (.NOT.ALLOCATED(buff_tmp2)) THEN
+      WRITE(*,*) "histwrite_real 1.1 allocate tbf_2 ",SIZE(tbf_1)
+    ENDIF
+    ALLOCATE(tbf_2(W_F(idf)%W_V(iv)%datasz_max))
+  ELSE IF (W_F(idf)%W_V(iv)%datasz_max > SIZE(tbf_2)) THEN
     IF (l_dbg) THEN
-      WRITE(*,*) "histwrite_real 1.1 allocate buff_tmp2 ",SIZE(buff_tmp)
-    ENDIF
-    ALLOCATE(buff_tmp2(datasz_max(pfileid,varid)))
-    buff_tmp2_sz = datasz_max(pfileid,varid)
-  ELSE IF (datasz_max(pfileid,varid) > buff_tmp2_sz) THEN
-    IF (l_dbg) THEN
-      WRITE(*,*) "histwrite_real 1.2 re-allocate buff_tmp2 : ", &
-     & SIZE(buff_tmp)," instead of ",SIZE(buff_tmp2)
-    ENDIF
-    DEALLOCATE(buff_tmp2)
-    ALLOCATE(buff_tmp2(datasz_max(pfileid,varid)))
-    buff_tmp2_sz = datasz_max(pfileid,varid)
-  ENDIF
-!-
-  rtime = pitau * deltat(pfileid)
-  tmp_opp = topp(pfileid,varid)
-!-
-! 3.0 Do the operations or transfer the slab of data into buff_tmp
-!-
-  IF (l_dbg) WRITE(*,*) "histwrite: 3.0",pfileid
+      WRITE(*,*) "histwrite_real 1.2 re-allocate tbf_2 : ", &
+     & SIZE(tbf_1)," instead of ",SIZE(tbf_2)
+    ENDIF
+    DEALLOCATE(tbf_2)
+    ALLOCATE(tbf_2(W_F(idf)%W_V(iv)%datasz_max))
+  ENDIF
+!-
+  rtime = pitau*W_F(idf)%deltat
+  tmp_opp = W_F(idf)%W_V(iv)%topp
+!-
+! 3.0 Do the operations or transfer the slab of data into tbf_1
+!-
+  IF (l_dbg) THEN
+    WRITE(*,*) "histwrite: 3.0",idf
+  ENDIF
 !-
 ! 3.1 DO the Operations only if needed
 !-
   IF (do_oper) THEN
-    i = pfileid
     nbout = nbdpt
 !-
@@ -2036,21 +1917,23 @@
 !--     we started in the interface routine
 !-
-    DO io = 2,nbopp(i,varid),2
+    DO io=2,W_F(idf)%W_V(iv)%nbopp,2
       nbin = nbout
-      nbout = datasz_max(i,varid)
-      CALL mathop(sopps(i,varid,io),nbin,buff_tmp,missing_val, &
- &      nbindex,nindex,scal(i,varid,io),nbout,buff_tmp2)
+      nbout = W_F(idf)%W_V(iv)%datasz_max
+      CALL mathop(W_F(idf)%W_V(iv)%sopp(io),nbin,tbf_1, &
+ &      missing_val,nbindex,nindex,W_F(idf)%W_V(iv)%scal(io), &
+ &      nbout,tbf_2)
       IF (l_dbg) THEN
         WRITE(*,*) &
- &       "histwrite: 3.4a nbout : ",nbin,nbout,sopps(i,varid,io)
+ &       "histwrite: 3.4a nbout : ",nbin,nbout,W_F(idf)%W_V(iv)%sopp(io)
       ENDIF
 !-
       nbin = nbout
-      nbout = datasz_max(i,varid)
-      CALL mathop(sopps(i,varid,io+1),nbin,buff_tmp2,missing_val, &
- &      nbindex,nindex,scal(i,varid,io+1),nbout,buff_tmp)
+      nbout = W_F(idf)%W_V(iv)%datasz_max
+      CALL mathop(W_F(idf)%W_V(iv)%sopp(io+1),nbin,tbf_2, &
+ &      missing_val,nbindex,nindex,W_F(idf)%W_V(iv)%scal(io+1), &
+ &      nbout,tbf_1)
       IF (l_dbg) THEN
         WRITE(*,*) &
- &       "histwrite: 3.4b nbout : ",nbin,nbout,sopps(i,varid,io+1)
+ &     "histwrite: 3.4b nbout : ",nbin,nbout,W_F(idf)%W_V(iv)%sopp(io+1)
       ENDIF
     ENDDO
@@ -2060,78 +1943,88 @@
     IF (l_dbg) THEN
       WRITE(*,*) &
- &     "histwrite: 3.5 size(buff_tmp) : ",SIZE(buff_tmp)
+ &     "histwrite: 3.5 size(tbf_1) : ",SIZE(tbf_1)
       WRITE(*,*) &
- &     "histwrite: 3.5 slab in X :",zorig(i,varid,1),zsize(i,varid,1)
+ &     "histwrite: 3.5 slab in X :", &
+ &     W_F(idf)%W_V(iv)%zorig(1),W_F(idf)%W_V(iv)%zsize(1)
       WRITE(*,*) &
- &     "histwrite: 3.5 slab in Y :",zorig(i,varid,2),zsize(i,varid,2)
+ &     "histwrite: 3.5 slab in Y :", &
+ &     W_F(idf)%W_V(iv)%zorig(2),W_F(idf)%W_V(iv)%zsize(2)
       WRITE(*,*) &
- &     "histwrite: 3.5 slab in Z :",zorig(i,varid,3),zsize(i,varid,3)
+ &     "histwrite: 3.5 slab in Z :", &
+ &     W_F(idf)%W_V(iv)%zorig(3),W_F(idf)%W_V(iv)%zsize(3)
       WRITE(*,*) &
  &     "histwrite: 3.5 slab of input:", &
- &     scsize(i,varid,1),scsize(i,varid,2),scsize(i,varid,3)
+ &     W_F(idf)%W_V(iv)%scsize(1), &
+ &     W_F(idf)%W_V(iv)%scsize(2), &
+ &     W_F(idf)%W_V(iv)%scsize(3)
     ENDIF
 !---
 !-- We have to consider blocks of contiguous data
 !---
-    nx=MAX(zsize(i,varid,1),1)
-    ny=MAX(zsize(i,varid,2),1)
-    nz=MAX(zsize(i,varid,3),1)
-    IF     (     (zorig(i,varid,1) == 1) &
-   &        .AND.(zsize(i,varid,1) == scsize(i,varid,1)) &
-   &        .AND.(zorig(i,varid,2) == 1) &
-   &        .AND.(zsize(i,varid,2) == scsize(i,varid,2))) THEN
-      kt = (zorig(i,varid,3)-1)*nx*ny
-      buff_tmp2(1:nx*ny*nz) = buff_tmp(kt+1:kt+nx*ny*nz)
-    ELSEIF (     (zorig(i,varid,1) == 1) &
-   &        .AND.(zsize(i,varid,1) == scsize(i,varid,1))) THEN
+    nx=MAX(W_F(idf)%W_V(iv)%zsize(1),1)
+    ny=MAX(W_F(idf)%W_V(iv)%zsize(2),1)
+    nz=MAX(W_F(idf)%W_V(iv)%zsize(3),1)
+    IF     (     (W_F(idf)%W_V(iv)%zorig(1) == 1) &
+ &          .AND.(   W_F(idf)%W_V(iv)%zsize(1) &
+ &                == W_F(idf)%W_V(iv)%scsize(1)) &
+ &          .AND.(W_F(idf)%W_V(iv)%zorig(2) == 1) &
+ &          .AND.(   W_F(idf)%W_V(iv)%zsize(2) &
+ &                == W_F(idf)%W_V(iv)%scsize(2))) THEN
+      kt = (W_F(idf)%W_V(iv)%zorig(3)-1)*nx*ny
+      tbf_2(1:nx*ny*nz) = tbf_1(kt+1:kt+nx*ny*nz)
+    ELSEIF (     (W_F(idf)%W_V(iv)%zorig(1) == 1) &
+ &          .AND.(   W_F(idf)%W_V(iv)%zsize(1) &
+ &                == W_F(idf)%W_V(iv)%scsize(1))) THEN
       kc = -nx*ny
-      DO kz=zorig(i,varid,3),zorig(i,varid,3)+nz-1
+      DO kz=W_F(idf)%W_V(iv)%zorig(3),W_F(idf)%W_V(iv)%zorig(3)+nz-1
         kc = kc+nx*ny
-        kt = ((kz-1)*scsize(i,varid,2)+zorig(i,varid,2)-1)*nx
-        buff_tmp2(kc+1:kc+nx*ny) = buff_tmp(kt+1:kt+nx*ny)
+        kt = ( (kz-1)*W_F(idf)%W_V(iv)%scsize(2) &
+ &            +W_F(idf)%W_V(iv)%zorig(2)-1)*nx
+        tbf_2(kc+1:kc+nx*ny) = tbf_1(kt+1:kt+nx*ny)
       ENDDO
     ELSE
       kc = -nx
-      DO kz=zorig(i,varid,3),zorig(i,varid,3)+nz-1
-        DO ky=zorig(i,varid,2),zorig(i,varid,2)+ny-1
+      DO kz=W_F(idf)%W_V(iv)%zorig(3),W_F(idf)%W_V(iv)%zorig(3)+nz-1
+        DO ky=W_F(idf)%W_V(iv)%zorig(2),W_F(idf)%W_V(iv)%zorig(2)+ny-1
           kc = kc+nx
-          kt = ((kz-1)*scsize(i,varid,2)+ky-1)*scsize(i,varid,1) &
-   &          +zorig(i,varid,1)-1
-          buff_tmp2(kc+1:kc+nx) = buff_tmp(kt+1:kt+nx)
+          kt = ((kz-1)*W_F(idf)%W_V(iv)%scsize(2)+ky-1) &
+ &            *W_F(idf)%W_V(iv)%scsize(1) &
+ &            +W_F(idf)%W_V(iv)%zorig(1)-1
+          tbf_2(kc+1:kc+nx) = tbf_1(kt+1:kt+nx)
         ENDDO
       ENDDO
     ENDIF
 !-
-!-- 4.0 Get the min and max of the field (buff_tmp)
-!-
-    IF (l_dbg) WRITE(*,*) "histwrite: 4.0 buff_tmp",pfileid,varid, &
- &    TRIM(tmp_opp),' ---- ',LEN_TRIM(tmp_opp),nbindex
-!-
-    IF (hist_calc_rng(pfileid,varid)) THEN
-      hist_minmax(pfileid,varid,1) = &
- &      MIN(hist_minmax(pfileid,varid,1), &
- &      MINVAL(buff_tmp2(1:tsz),MASK=buff_tmp2(1:tsz) /= missing_val))
-      hist_minmax(pfileid,varid,2) = &
- &      MAX(hist_minmax(pfileid,varid,2), &
- &      MAXVAL(buff_tmp2(1:tsz),MASK=buff_tmp2(1:tsz) /= missing_val))
+!-- 4.0 Get the min and max of the field
+!-
+    IF (l_dbg) THEN
+      WRITE(*,*) "histwrite: 4.0 tbf_1",idf,iv, &
+ &      TRIM(tmp_opp),' ---- ',LEN_TRIM(tmp_opp),nbindex
+    ENDIF
+!-
+    IF (W_F(idf)%W_V(iv)%hist_calc_rng) THEN
+      W_F(idf)%W_V(iv)%hist_minmax(1) = &
+ &      MIN(W_F(idf)%W_V(iv)%hist_minmax(1), &
+ &      MINVAL(tbf_2(1:tsz),MASK=tbf_2(1:tsz) /= missing_val))
+      W_F(idf)%W_V(iv)%hist_minmax(2) = &
+ &      MAX(W_F(idf)%W_V(iv)%hist_minmax(2), &
+ &      MAXVAL(tbf_2(1:tsz),MASK=tbf_2(1:tsz) /= missing_val))
     ENDIF
 !-
 !-- 5.0 Do the operations if needed. In the case of instantaneous
-!--     output we do not transfer to the buffer.
-!-
-    IF (l_dbg) WRITE(*,*) "histwrite: 5.0",pfileid,"tsz :",tsz
-!-
-    ipt = point(pfileid,varid)
-!-
-!   WRITE(*,*) 'OPE ipt, buffer :',pvarname,ipt,varid
+!--     output we do not transfer to the time_buffer.
+!-
+    IF (l_dbg) THEN
+      WRITE(*,*) "histwrite: 5.0 idf : ",idf," iv : ",iv," tsz : ",tsz
+    ENDIF
 !-
     IF (     (TRIM(tmp_opp) /= "inst") &
-   &    .AND.(TRIM(tmp_opp) /= "once") ) THEN
-      CALL moycum(tmp_opp,tsz,buffer(ipt:), &
-     &       buff_tmp2,nb_opp(pfileid,varid))
-    ENDIF
-!-
-    last_opp(pfileid,varid) = pitau
-    nb_opp(pfileid,varid) = nb_opp(pfileid,varid)+1
+ &      .AND.(TRIM(tmp_opp) /= "once") ) THEN
+      CALL moycum(tmp_opp,tsz,W_F(idf)%W_V(iv)%t_bf, &
+ &           tbf_2,W_F(idf)%W_V(iv)%nb_opp)
+    ENDIF
+!-
+    W_F(idf)%W_V(iv)%last_opp = pitau
+    W_F(idf)%W_V(iv)%nb_opp = W_F(idf)%W_V(iv)%nb_opp+1
 !-
   ENDIF
@@ -2139,18 +2032,19 @@
 ! 6.0 Write to file if needed
 !-
-  IF (l_dbg) WRITE(*,*) "histwrite: 6.0",pfileid
+  IF (l_dbg) WRITE(*,*) "histwrite: 6.0",idf
 !-
   IF (do_write) THEN
 !-
-    ncvarid = ncvar_ids(pfileid,varid)
-    ncid = ncdf_ids(pfileid)
+    nfid = W_F(idf)%ncfid
+    nvid = W_F(idf)%W_V(iv)%ncvid
 !-
 !-- 6.1 Do the operations that are needed before writting
 !-
-    IF (l_dbg) WRITE(*,*) "histwrite: 6.1",pfileid
+    IF (l_dbg) WRITE(*,*) "histwrite: 6.1",idf
 !-
     IF (     (TRIM(tmp_opp) /= "inst") &
-   &    .AND.(TRIM(tmp_opp) /= "once") ) THEN
-      rtime = (rtime+last_wrt(pfileid,varid)*deltat(pfileid))/2.0
+ &      .AND.(TRIM(tmp_opp) /= "once") ) THEN
+      t_bnd(1:2) = (/ W_F(idf)%W_V(iv)%last_wrt*W_F(idf)%deltat,rtime /)
+      rtime = (t_bnd(1)+t_bnd(2))/2.0
     ENDIF
 !-
@@ -2158,16 +2052,20 @@
 !-
     IF (     (TRIM(tmp_opp) /= "l_max") &
-   &    .AND.(TRIM(tmp_opp) /= "l_min") &
-   &    .AND.(TRIM(tmp_opp) /= "once") ) THEN
-!-
-      IF (l_dbg) WRITE(*,*) "histwrite: 6.2",pfileid
-!-
-      itax = var_axid(pfileid,varid)
-      itime = nb_wrt(pfileid,varid)+1
-!-
-      IF (tax_last(pfileid,itax) < itime) THEN
-        iret = NF90_PUT_VAR (ncid,tdimid(pfileid,itax),(/ rtime /), &
- &                            start=(/ itime /),count=(/ 1 /))
-        tax_last(pfileid,itax) = itime
+ &      .AND.(TRIM(tmp_opp) /= "l_min") &
+ &      .AND.(TRIM(tmp_opp) /= "once") ) THEN
+!-
+      IF (l_dbg) WRITE(*,*) "histwrite: 6.2",idf
+!-
+      itax  = W_F(idf)%W_V(iv)%t_axid
+      itime = W_F(idf)%W_V(iv)%nb_wrt+1
+!-
+      IF (W_F(idf)%W_V(itax)%tax_last < itime) THEN
+        iret = NF90_PUT_VAR (nfid,W_F(idf)%W_V(itax)%tdimid, &
+ &               (/ rtime /),start=(/ itime /),count=(/ 1 /))
+        IF (W_F(idf)%W_V(itax)%tbndid > 0) THEN
+          iret = NF90_PUT_VAR (nfid,W_F(idf)%W_V(itax)%tbndid, &
+ &                 t_bnd,start=(/ 1,itime /),count=(/ 2,1 /))
+        ENDIF
+        W_F(idf)%W_V(itax)%tax_last = itime
       ENDIF
     ELSE
@@ -2179,43 +2077,41 @@
 !-
     IF (l_dbg) THEN
-      WRITE(*,*) "histwrite: 6.3",pfileid,ncid,ncvarid,varid,itime
-    ENDIF
-!-
-    IF (scsize(pfileid,varid,3) == 1) THEN
-      IF (regular(pfileid)) THEN
+      WRITE(*,*) "histwrite: 6.3",idf,nfid,nvid,iv,itime
+    ENDIF
+!-
+    IF (W_F(idf)%W_V(iv)%scsize(3) == 1) THEN
+      IF (W_F(idf)%regular) THEN
         corner(1:4) = (/ 1,1,itime,0 /)
-        edges(1:4) = (/ zsize(pfileid,varid,1), &
- &                      zsize(pfileid,varid,2),1,0 /)
+        edges(1:4) = (/ W_F(idf)%W_V(iv)%zsize(1), &
+ &                      W_F(idf)%W_V(iv)%zsize(2),1,0 /)
       ELSE
         corner(1:4) = (/ 1,itime,0,0 /)
-        edges(1:4) = (/ zsize(pfileid,varid,1),1,0,0 /)
+        edges(1:4) = (/ W_F(idf)%W_V(iv)%zsize(1),1,0,0 /)
       ENDIF
     ELSE
-      IF (regular(pfileid)) THEN
+      IF (W_F(idf)%regular) THEN
         corner(1:4) = (/ 1,1,1,itime /)
-        edges(1:4) = (/ zsize(pfileid,varid,1), &
- &                      zsize(pfileid,varid,2), &
- &                      zsize(pfileid,varid,3),1 /)
+        edges(1:4) = (/ W_F(idf)%W_V(iv)%zsize(1), &
+ &                      W_F(idf)%W_V(iv)%zsize(2), &
+ &                      W_F(idf)%W_V(iv)%zsize(3),1 /)
       ELSE
         corner(1:4) = (/ 1,1,itime,0 /)
-        edges(1:4) = (/ zsize(pfileid,varid,1), &
- &                      zsize(pfileid,varid,3),1,0 /)
+        edges(1:4) = (/ W_F(idf)%W_V(iv)%zsize(1), &
+ &                      W_F(idf)%W_V(iv)%zsize(3),1,0 /)
       ENDIF
     ENDIF
-!-
-    ipt = point(pfileid,varid)
 !-
     IF (     (TRIM(tmp_opp) /= "inst") &
  &      .AND.(TRIM(tmp_opp) /= "once") ) THEN
-      iret = NF90_PUT_VAR (ncid,ncvarid,buffer(ipt:), &
- &                       start=corner(1:4),count=edges(1:4))
+      iret = NF90_PUT_VAR (nfid,nvid,W_F(idf)%W_V(iv)%t_bf, &
+ &                         start=corner(1:4),count=edges(1:4))
     ELSE
-      iret = NF90_PUT_VAR (ncid,ncvarid,buff_tmp2, &
- &                       start=corner(1:4),count=edges(1:4))
-    ENDIF
-!-
-    last_wrt(pfileid,varid) = pitau
-    nb_wrt(pfileid,varid) = nb_wrt(pfileid,varid)+1
-    nb_opp(pfileid,varid) = 0
+      iret = NF90_PUT_VAR (nfid,nvid,tbf_2, &
+ &                         start=corner(1:4),count=edges(1:4))
+    ENDIF
+!-
+    W_F(idf)%W_V(iv)%last_wrt = pitau
+    W_F(idf)%W_V(iv)%nb_wrt = W_F(idf)%W_V(iv)%nb_wrt+1
+    W_F(idf)%W_V(iv)%nb_opp = 0
 !---
 !   After the write the file can be synchronized so that no data is
@@ -2224,5 +2120,5 @@
 !   needed here to switch to this mode.
 !---
-!   iret = NF90_SYNC (ncid)
+!   iret = NF90_SYNC (nfid)
 !-
   ENDIF
@@ -2230,7 +2126,7 @@
 END SUBROUTINE histwrite_real
 !===
-SUBROUTINE histvar_seq (pfid,pvarname,pvid)
-!---------------------------------------------------------------------
-!- This subroutine optimized the search for the variable in the table.
+SUBROUTINE histvar_seq (idf,pvarname,idv)
+!---------------------------------------------------------------------
+!- This subroutine optimize the search for the variable in the table.
 !- In a first phase it will learn the succession of the variables
 !- called and then it will use the table to guess what comes next.
@@ -2240,13 +2136,13 @@
 !- ARGUMENTS :
 !-
-!- pfid  : id of the file on which we work
+!- idf      : id of the file on which we work
 !- pvarname : The name of the variable we are looking for
-!- pvid     : The var id we found
+!- idv      : The var id we found
 !---------------------------------------------------------------------
   IMPLICIT NONE
 !-
-  INTEGER,INTENT(in)  :: pfid
+  INTEGER,INTENT(in)  :: idf
   CHARACTER(LEN=*),INTENT(IN) :: pvarname
-  INTEGER,INTENT(out) :: pvid
+  INTEGER,INTENT(out) :: idv
 !-
   LOGICAL,SAVE :: learning(nb_files_max)=.TRUE.
@@ -2263,17 +2159,17 @@
 !-
   IF (l_dbg) THEN
-    WRITE(*,*) 'histvar_seq, start of the subroutine :',learning(pfid)
-  ENDIF
-!-
-  IF (learning(pfid)) THEN
+    WRITE(*,*) 'histvar_seq, start of the subroutine :',learning(idf)
+  ENDIF
+!-
+  IF (learning(idf)) THEN
 !-
 !-- 1.0 We compute the length over which we are going
 !--     to check the overlap
 !-
-    IF (overlap(pfid) <= 0) THEN
-      IF (nb_var(pfid) > 6) THEN
-        overlap(pfid) = nb_var(pfid)/3*2
+    IF (overlap(idf) <= 0) THEN
+      IF (W_F(idf)%n_var > 6) THEN
+        overlap(idf) = W_F(idf)%n_var/3*2
       ELSE
-        overlap(pfid) = nb_var(pfid)
+        overlap(idf) = W_F(idf)%n_var
       ENDIF
     ENDIF
@@ -2281,7 +2177,7 @@
 !-- 1.1 Find the position of this string
 !-
-    CALL find_str (name(pfid,1:nb_var(pfid)),pvarname,pos)
+    CALL find_str (W_F(idf)%W_V(1:W_F(idf)%n_var)%v_name,pvarname,pos)
     IF (pos > 0) THEN
-      pvid = pos
+      idv = pos
     ELSE
       CALL ipslerr (3,"histvar_seq", &
@@ -2294,9 +2190,9 @@
 !--     in the sequence of calls
 !-
-    IF (varseq_err(pfid) >= 0) THEN
-      sp = varseq_len(pfid)+1
+    IF (varseq_err(idf) >= 0) THEN
+      sp = varseq_len(idf)+1
       IF (sp <= nb_var_max*3) THEN
-        varseq(pfid,sp) = pvid
-        varseq_len(pfid) = sp
+        varseq(idf,sp) = idv
+        varseq_len(idf) = sp
       ELSE
         CALL ipslerr (2,"histvar_seq",&
@@ -2308,24 +2204,24 @@
  &       ' contact the IOIPSL team. ')
         WRITE(*,*) 'The sequence we have found up to now :'
-        WRITE(*,*) varseq(pfid,1:sp-1)
-        varseq_err(pfid) = -1
+        WRITE(*,*) varseq(idf,1:sp-1)
+        varseq_err(idf) = -1
       ENDIF
 !-
 !---- 1.3 Check if we have found the right overlap
 !-
-      IF (varseq_len(pfid) .GE. overlap(pfid)*2) THEN
+      IF (varseq_len(idf) >= overlap(idf)*2) THEN
 !-
 !------ We skip a few variables if needed as they could come
 !------ from the initialisation of the model.
 !-
-        DO ib = 0,sp-overlap(pfid)*2
-          IF ( learning(pfid) .AND.&
-            & SUM(ABS(varseq(pfid,ib+1:ib+overlap(pfid)) -&
-            & varseq(pfid,sp-overlap(pfid)+1:sp))) == 0 ) THEN
-            learning(pfid) = .FALSE.
-            varseq_len(pfid) = sp-overlap(pfid)-ib
-            varseq_pos(pfid) = overlap(pfid)+ib
-            varseq(pfid,1:varseq_len(pfid)) = &
- &            varseq(pfid,ib+1:ib+varseq_len(pfid))
+        DO ib = 0,sp-overlap(idf)*2
+          IF ( learning(idf) .AND.&
+            & SUM(ABS(varseq(idf,ib+1:ib+overlap(idf)) -&
+            & varseq(idf,sp-overlap(idf)+1:sp))) == 0 ) THEN
+            learning(idf) = .FALSE.
+            varseq_len(idf) = sp-overlap(idf)-ib
+            varseq_pos(idf) = overlap(idf)+ib
+            varseq(idf,1:varseq_len(idf)) = &
+ &            varseq(idf,ib+1:ib+varseq_len(idf))
           ENDIF
         ENDDO
@@ -2337,13 +2233,13 @@
 !--     and we can get a guess at the var ID
 !-
-    nn = varseq_pos(pfid)+1
-    IF (nn > varseq_len(pfid)) nn = 1
-!-
-    pvid = varseq(pfid,nn)
-!-
-    IF (TRIM(name(pfid,pvid)) /= TRIM(pvarname)) THEN
-      CALL find_str (name(pfid,1:nb_var(pfid)),pvarname,pos)
+    nn = varseq_pos(idf)+1
+    IF (nn > varseq_len(idf)) nn = 1
+!-
+    idv = varseq(idf,nn)
+!-
+    IF (TRIM(W_F(idf)%W_V(idv)%v_name) /= TRIM(pvarname)) THEN
+      CALL find_str (W_F(idf)%W_V(1:W_F(idf)%n_var)%v_name,pvarname,pos)
       IF (pos > 0) THEN
-        pvid = pos
+        idv = pos
       ELSE
         CALL ipslerr (3,"histvar_seq", &
@@ -2352,5 +2248,5 @@
  &  TRIM(pvarname))
       ENDIF
-      varseq_err(pfid) = varseq_err(pfid)+1
+      varseq_err(idf) = varseq_err(idf)+1
     ELSE
 !-
@@ -2359,13 +2255,13 @@
 !---- not defeat the process.
 !-
-      varseq_pos(pfid) = nn
-    ENDIF
-!-
-    IF (varseq_err(pfid) .GE. 10) THEN
-      WRITE(str70,'("for file ",I3)') pfid
+      varseq_pos(idf) = nn
+    ENDIF
+!-
+    IF (varseq_err(idf) >= 10) THEN
+      WRITE(str70,'("for file ",I3)') idf
       CALL ipslerr (2,"histvar_seq", &
  &  'There were 10 errors in the learned sequence of variables',&
  &  str70,'This looks like a bug, please report it.')
-         varseq_err(pfid) = 0
+         varseq_err(idf) = 0
     ENDIF
   ENDIF
@@ -2373,10 +2269,10 @@
   IF (l_dbg) THEN
     WRITE(*,*) &
- &   'histvar_seq, end of the subroutine :',TRIM(pvarname),pvid
+ &   'histvar_seq, end of the subroutine :',TRIM(pvarname),idv
   ENDIF
 !-------------------------
 END SUBROUTINE histvar_seq
 !===
-SUBROUTINE histsync (file)
+SUBROUTINE histsync (idf)
 !---------------------------------------------------------------------
 !- This subroutine will synchronise all
@@ -2388,39 +2284,52 @@
   IMPLICIT NONE
 !-
-! file  : optional argument for fileid
-  INTEGER,INTENT(in),OPTIONAL :: file
-!-
-  INTEGER :: ifile,ncid,iret
-!-
-  LOGICAL :: file_exists
+! idf  : optional argument for fileid
+  INTEGER,INTENT(in),OPTIONAL :: idf
+!-
+  INTEGER :: ifile,iret,i_s,i_e
+!-
   LOGICAL :: l_dbg
 !---------------------------------------------------------------------
   CALL ipsldbg (old_status=l_dbg)
 !-
-  IF (l_dbg) WRITE(*,*) 'Entering loop on files : ',nb_files
-!-
-! 1.The loop on files to synchronise
-!-
-  DO ifile = 1,nb_files
-!-
-    IF (PRESENT(file)) THEN
-      file_exists = (ifile == file)
+  IF (l_dbg) THEN
+    WRITE(*,*) "->histsync"
+  ENDIF
+!-
+  IF (PRESENT(idf)) THEN
+    IF ( (idf >= 1).AND.(idf <= nb_files_max) ) THEN
+      IF (W_F(idf)%ncfid > 0) THEN
+        i_s = idf
+        i_e = idf
+      ELSE
+        i_s = 1
+        i_e = 0
+        CALL ipslerr (2,'histsync', &
+ &       'Unable to synchronise the file :','probably','not opened')
+      ENDIF
     ELSE
-      file_exists = .TRUE.
-    ENDIF
-!-
-    IF (file_exists) THEN
+      CALL ipslerr (3,'histsync','Invalid file identifier',' ',' ')
+    ENDIF
+  ELSE
+    i_s = 1
+    i_e = nb_files_max
+  ENDIF
+!-
+  DO ifile=i_s,i_e
+    IF (W_F(ifile)%ncfid > 0) THEN
       IF (l_dbg) THEN
-        WRITE(*,*) 'Synchronising specified file number :',file
+        WRITE(*,*) '  histsync - synchronising file number ',ifile
       ENDIF
-      ncid = ncdf_ids(ifile)
-      iret = NF90_SYNC (ncid)
-    ENDIF
-!-
+      iret = NF90_SYNC(W_F(ifile)%ncfid)
+    ENDIF
   ENDDO
+!-
+  IF (l_dbg) THEN
+    WRITE(*,*) "<-histsync"
+  ENDIF
 !----------------------
 END SUBROUTINE histsync
 !===
-SUBROUTINE histclo (fid)
+SUBROUTINE histclo (idf)
 !---------------------------------------------------------------------
 !- This subroutine will close all (or one if defined) opened files
@@ -2431,59 +2340,94 @@
   IMPLICIT NONE
 !-
-! fid  : optional argument for fileid
-  INTEGER,INTENT(in),OPTIONAL :: fid
-!-
-  INTEGER :: ifile,ncid,iret,iv
-  INTEGER :: start_loop,end_loop
-  CHARACTER(LEN=70) :: str70
+! idf  : optional argument for fileid
+  INTEGER,INTENT(in),OPTIONAL :: idf
+!-
+  INTEGER :: ifile,nfid,nvid,iret,iv,i_s,i_e
   LOGICAL :: l_dbg
 !---------------------------------------------------------------------
   CALL ipsldbg (old_status=l_dbg)
 !-
-  IF (l_dbg) WRITE(*,*) 'Entering loop on files :',nb_files
-!-
-  IF (PRESENT(fid)) THEN
-    start_loop = fid
-    end_loop = fid
+  IF (l_dbg) THEN
+    WRITE(*,*) "->histclo"
+  ENDIF
+!-
+  IF (PRESENT(idf)) THEN
+    IF ( (idf >= 1).AND.(idf <= nb_files_max) ) THEN
+      IF (W_F(idf)%ncfid > 0) THEN
+        i_s = idf
+        i_e = idf
+      ELSE
+        i_s = 1
+        i_e = 0
+        CALL ipslerr (2,'histclo', &
+ &       'Unable to close the file :','probably','not opened')
+      ENDIF
+    ELSE
+      CALL ipslerr (3,'histclo','Invalid file identifier',' ',' ')
+    ENDIF
   ELSE
-    start_loop = 1
-    end_loop = nb_files
-  ENDIF
-!-
-  DO ifile=start_loop,end_loop
-    IF (l_dbg) WRITE(*,*) 'Closing specified file number :',ifile
-    ncid = ncdf_ids(ifile)
-    iret = NF90_REDEF (ncid)
-!---
-!-- 1. Loop on the number of variables to add some final information
-!---
-    IF (l_dbg) WRITE(*,*) 'Entering loop on vars : ',nb_var(ifile)
-    DO iv=1,nb_var(ifile)
-      IF (hist_wrt_rng(ifile,iv)) THEN
-        IF (l_dbg) THEN
-          WRITE(*,*) 'min value for file :',ifile,' var n. :',iv, &
-         &           ' is : ',hist_minmax(ifile,iv,1)
-          WRITE(*,*) 'max value for file :',ifile,' var n. :',iv, &
-         &           ' is : ',hist_minmax(ifile,iv,2)
+    i_s = 1
+    i_e = nb_files_max
+  ENDIF
+!-
+  DO ifile=i_s,i_e
+    IF (W_F(ifile)%ncfid > 0) THEN
+      IF (l_dbg) THEN
+        WRITE(*,*) '  histclo - closing specified file number :',ifile
+      ENDIF
+      nfid = W_F(ifile)%ncfid
+      iret = NF90_REDEF(nfid)
+!-----
+!---- 1. Loop on the number of variables to add some final information
+!-----
+      IF (l_dbg) THEN
+        WRITE(*,*) '  Entering loop on vars : ',W_F(ifile)%n_var
+      ENDIF
+      DO iv=1,W_F(ifile)%n_var
+!------ Extrema
+        IF (W_F(ifile)%W_V(iv)%hist_wrt_rng) THEN
+          IF (l_dbg) THEN
+            WRITE(*,*) 'min value for file :',ifile,' var n. :',iv, &
+ &                     ' is : ',W_F(ifile)%W_V(iv)%hist_minmax(1)
+            WRITE(*,*) 'max value for file :',ifile,' var n. :',iv, &
+ &                     ' is : ',W_F(ifile)%W_V(iv)%hist_minmax(2)
+          ENDIF
+          IF (W_F(ifile)%W_V(iv)%hist_calc_rng) THEN
+!---------- Put the min and max values on the file
+            nvid = W_F(ifile)%W_V(iv)%ncvid
+            IF (W_F(ifile)%W_V(iv)%v_typ == hist_r8) THEN
+              iret = NF90_PUT_ATT(nfid,nvid,'valid_min', &
+ &                     REAL(W_F(ifile)%W_V(iv)%hist_minmax(1),KIND=8))
+              iret = NF90_PUT_ATT(nfid,nvid,'valid_max', &
+ &                     REAL(W_F(ifile)%W_V(iv)%hist_minmax(2),KIND=8))
+            ELSE
+              iret = NF90_PUT_ATT(nfid,nvid,'valid_min', &
+ &                     REAL(W_F(ifile)%W_V(iv)%hist_minmax(1),KIND=4))
+              iret = NF90_PUT_ATT(nfid,nvid,'valid_max', &
+ &                     REAL(W_F(ifile)%W_V(iv)%hist_minmax(2),KIND=4))
+            ENDIF
+          ENDIF
         ENDIF
-        IF (hist_calc_rng(ifile,iv)) THEN
-!-------- Put the min and max values on the file
-          iret = NF90_PUT_ATT (ncid,ncvar_ids(ifile,iv),'valid_min', &
- &                             REAL(hist_minmax(ifile,iv,1),KIND=4))
-          iret = NF90_PUT_ATT (ncid,ncvar_ids(ifile,iv),'valid_max', &
- &                             REAL(hist_minmax(ifile,iv,2),KIND=4))
+!------ Time-Buffers
+        IF (ASSOCIATED(W_F(ifile)%W_V(iv)%t_bf)) THEN
+          DEALLOCATE(W_F(ifile)%W_V(iv)%t_bf)
         ENDIF
-      ENDIF
-    ENDDO
-!---
-!-- 2. Close the file
-!---
-    IF (l_dbg) WRITE(*,*) 'close file :',ncid
-    iret = NF90_CLOSE (ncid)
-    IF (iret /= NF90_NOERR) THEN
-      WRITE(str70,'("This file has been already closed :",I3)') ifile
-      CALL ipslerr (2,'histclo',str70,'','')
+!------ Reinitialize the sizes
+        W_F(ifile)%W_V(iv)%datasz_in(:) = -1
+        W_F(ifile)%W_V(iv)%datasz_max = -1
+      ENDDO
+!-----
+!---- 2. Close the file
+!-----
+      IF (l_dbg) WRITE(*,*) '  close file :',nfid
+      iret = NF90_CLOSE(nfid)
+      W_F(ifile)%ncfid = -1
+      W_F(ifile)%dom_id_svg = -1
     ENDIF
   ENDDO
+!-
+  IF (l_dbg) THEN
+    WRITE(*,*) "<-histclo"
+  ENDIF
 !---------------------
 END SUBROUTINE histclo
